%% Localisation et Navigation de Robots - TD2 %%

clear all
close all
clc

addpath('outils/')

nbIter = 100; % Nombre d'instants de la simulation

figure(1)
clf
hold on

initEnviro;  % Initialise le modle de l'environnement, c'est--dire l'ensemble 
             % des droites le modlisant dans le repre global
            
initRobot;   % Initialise les paramtres du robot

initBruits;  % Paramtres des bruits pour simuler une commande mal 
             % applique et pour simuler l'incertitude des odomtres
            
genereTrajs; % Gnration de la trajectoire du robot s'il applique 
             % parfaitement la commande
             % Gnration des droites qui dlimitent l'environnement
             % Gnration de la trajectoire relle du robot (commande bruite)

% phig et phid sont les mesures successives des codeurs des roues (en radians)

% alpha_droites_obs et r_droites_obs sont les mesures issues de la
% perception exteroceptive : les paramtres des quatre droites perues,
% centrs au repre du robot et ordonns selon l'angle (en premier, la
% droite perue face au robot, puis les autres en tournant dans le sens antihoraire)

% r est le rayon d'une roue
% L est la longueur de l'essieu

xOdom(1) = 0;
yOdom(1) = 0;
thetaOdom(1) = 0;

xEstime(1) = 0;
yEstime(1) = 0;
thetaEstime(1) = 0;

PEstime = 1e-4*eye(3);

for i=1:nbIter

    diff_phig = phig(i+1)-phig(i);
    diff_phid = -(phid(i+1)-phid(i));
    
    delta_sg = diff_phig*r;
    delta_sd = diff_phid*r;
    
    % Position calcule par odomtrie, pour faire la comparaison des rsultats  
    % (fonction dj vue dans le TD1)
    [xOdom(i+1), yOdom(i+1), thetaOdom(i+1)] = ...
        MAJEtatOdometrie(xOdom(i), yOdom(i), thetaOdom(i), delta_sg, delta_sd, L);
    
    % -- 1. Phase de Prdiction -- 
    %
    % La fonction groupe les deux fonctions du TD1: "MAJEtatOdometrie" pour
    % la prediction de pose et "propageErreurs" pour le calcul de la matrice de covariance

    % --> [....]
    
    % -- 2. Phase de correction (mise  jour de la pose du robot) --
    
    % --> [....]
    
end
hl(4) = plot(xEstime,yEstime, 'k', 'LineWidth', 3);
hl(5) = plot(xOdom,yOdom, 'r', 'LineWidth', 3);

% hold off
% axis equal
% axis([xmin xmax ymin ymax])
% title('Trajectoires du robot unicycle')
% xlabel('x [mm]')
% ylabel('y [mm]')
%  
% h = legend(hl, ...
%         ' Droites de l''environnement', ...
%         ' Application parfaite de la commande', ...
%         ' Relle (commande bruite)', ... 
%         ' Obtenue par EKF', ...
%         ' Obtenue par odomtrie','Location','NorthWest');
% set(h,'FontSize',10);
